
#include <X11/Xutil.h>
#include <SDL/SDL.h>
#include <SDL/SDL_syswm.h>

int
main(void)
{
    int rc = SDL_InitSubSystem(SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_NOPARACHUTE);
    SDL_Event event;
    SDL_SysWMinfo gSdlInfo;

    if (rc != 0)
    {
        printf("Error: SDL_InitSubSystem failed with message '%s'\n", SDL_GetError());
        return 1;
    }
    /* we need a video window for the keyboard stuff to work */
    if (!SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE | SDL_RESIZABLE))
    {
        printf("Error: could not set SDL video mode\n");
        return 1;
    }

    SDL_VERSION(&gSdlInfo.version);
    if (!SDL_GetWMInfo(&gSdlInfo))
    {
        printf("Error: failed to retrieve WM info\n");
        return 1;
    }

    SDL_WM_GrabInput(SDL_GRAB_ON);


//        rc = XGrabKeyboard(gSdlInfo.info.x11.display, gSdlInfo.info.x11.window, False, 
//                           GrabModeAsync, GrabModeAsync, CurrentTime);
    while (SDL_WaitEvent(&event))
    {
        printf("(event->type=%d)\n", event.type);
        if (event.type == SDL_KEYDOWN)
        {
            printf("DOWN:   MOD=%08x KEY=%08x %d %d\n",
                    SDL_GetModState(), event.key.keysym.scancode,
                    SDL_GetKeyState(NULL)[SDLK_RCTRL], SDL_GetKeyState(NULL)[SDLK_RSHIFT]);
        }
        else if (event.type == SDL_KEYUP)
        {
            printf("UP:     MOD=%08x KEY=%08x %d %d\n",
                    SDL_GetModState(), event.key.keysym.scancode,
                    SDL_GetKeyState(NULL)[SDLK_RCTRL], SDL_GetKeyState(NULL)[SDLK_RSHIFT]);
        }
        else if (event.type == SDL_MOUSEMOTION)
        {
            printf("MOTION: %d %d\n",
                    event.motion.x, event.motion.y);
        }
        else if (event.type == SDL_MOUSEBUTTONDOWN)
        {
            printf("BTNUP:  %x, %d\n",
                    event.button.button, event.button.state);
        }
        else if (event.type == SDL_MOUSEBUTTONUP)
        {
            printf("BTNUP:  %x, %d\n",
                    event.button.button, event.button.state);
        }
#if 0
        else if (event.type == SDL_ACTIVEEVENT)
        {
            printf("ACTIVE: %x %x\n",
                    ((SDL_ActiveEvent*)&event)->gain,
                    ((SDL_ActiveEvent*)&event)->state);
        }
#endif
        if (event.key.keysym.sym == SDLK_q)
            break;
    }
    
    SDL_Quit();
    return 0;
}
